//#define NDEBUG

#include <graphics.h>
#include <stdio.h>
#include <conio.h>
#include <process.h>
#include <stdlib.h>

#include "Voronoi.hpp"
#include "Vector.hpp"
#include "Clock.hpp"
#include "mouse.hpp"


#include <math.h>

int GetNearestPoint(int x, int y, ArrayP2d& pt);
void InitGraphics(void);
void Help(void);
void ExpandPolygon(Point2d& pc, Polygon& pol);


extern unsigned _stklen = 54321U;


void main(void) {
	unsigned int i;
    float fScaleDxDy = 7.0;
/*
    Vector vV(1,1,0);
    Vector vP(2,2,0);
	printf("\n vV  = ");    vV.Print();
	printf("\n vP  = ");    vP.Print();

    // distance from point vP to line vV passing through the origin
    vV.normaliza();
    Vector vP1 = vV * (vV | vP);
	printf("\n vV(norm)  = ");    vV.Print();
	printf("\n vP1       = ");    vP1.Print();
	float fDist = (vP1-vP).mod();
	printf("dist = %f\n", fDist);

    vV.normaliza();
    Vector vP1 = vV * (vV | vP);
	float fDist = (vP1-vP).mod();

    return;
*/



	InitGraphics();
	Help(); getch();


	IniMouse();
    HideMouseCursor();
	RATON pixie;

    char buffer[100];

	Voronoi   voronoi;
	ArrayP2d   point(50,10,"main.point");

	srand(0);
	float k;

	point.Clear();
	point.AddNext(Point2d(320,200));


	#define MAX_APOL 50
	int max_apol = MAX_APOL;
	Polygon * apol = new Polygon[max_apol];
	assert(apol);

	int ch;
	int i_does_shut_down=0;
	int i_does_redraw=1;
	int i_selected_point=0;


	int last_mouse_x;
	int last_mouse_y;
	int last_press=0;
	int result;
    int page=0;

    int bDelaunay=0;
	int bDoFill=1;
    int bDoVorNeigh = 0;

	while(!i_does_shut_down) {

        setcolor(WHITE);
        line(pixie.x, pixie.y, pixie.x+4, pixie.y+2);
        line(pixie.x, pixie.y, pixie.x+2, pixie.y+4);
        line(pixie.x, pixie.y, pixie.x+6, pixie.y+6);

        if(bDelaunay) {
        	sprintf(buffer, "Delaunay triangulation");
        } else {
        	sprintf(buffer, "Voronoi Diagram         %s  %s  (z,x)Scale:%3.1f",
				bDoVorNeigh? "       ": (bDoFill? "(f)Fill":"(f)Line"),
				bDoVorNeigh? "(n)Highlight Neighbours":"(n)No Neighbours",
	        	fScaleDxDy);


        }
        outtextxy(0,0,buffer);
        outtextxy(550,0,"(h)Help");


        setvisualpage(page);
        page=!page;

		setcolor(CYAN);

        // wait_vertical_retrace
        while(0x08 & inport(0x3DA)) ;
        while(!(0x08 & inport(0x3DA))) ;

        setactivepage(page);
        clearviewport();


		if(i_does_redraw) {
			voronoi.img_dx = 368/2 * fScaleDxDy;
			voronoi.img_dy = 280/2 * fScaleDxDy;
			result = voronoi.CalcAllPol(point, apol);
			if(result==NULL);
        }

        if(1) {

            if(bDelaunay) { // draw delunay diagram
				for(int i=0; i<point.Count(); i++) {
					for(int j=i+1; j<point.Count(); j++) {

						if(voronoi.AreNeighbours(apol[i], apol[j])) {
                            setcolor(YELLOW);
            	            line(point[i].x, point[i].y, point[j].x, point[j].y);
		                }
						else  {
						}

    				}
					setcolor(WHITE);
	                circle(point[i].x, point[i].y, 3);
				}


            }
            else {  // draw voronoi diagram

            	voronoi.m_ny=0;

				int color=0;
				for(i=0; i<point.Count(); i++) {

					color++; if(color>=13) color=1;

                    if(bDoVorNeigh) {
						if(voronoi.AreNeighbours(apol[i], apol[i_selected_point])) {
							setcolor(color);
		                	apol[i].Fill();
		                }
						else  {
							setcolor(CYAN);
							apol[i].Draw();
						}
    				}
                    else {  // don't do neighbours
						if(bDoFill) {
							setcolor(color);
		                	apol[i].Fill();
		                }
						else  {
							setcolor(CYAN);
							apol[i].Draw();
						}
    				}


					setcolor(WHITE);
	                circle(point[i].x, point[i].y, 3);
				}
                setcolor(WHITE);
                apol[i_selected_point].Draw();
    		}


			i_does_redraw = 0;

		}



		if(!kbhit()) {
			last_press = pixie.ib[0];
			GetMouseInstantPosition(&pixie);

			// Delete Point by pressing both mouse buttons
			if(pixie.ib[0] && pixie.ib[2]) {
				if(point.Count()>1) {
					point.DeleteAt(i_selected_point);
					i_selected_point = 0;
					i_does_redraw = 1;
					BEEP(1500,20);
				}
				else {
					BEEP(750,20);
				}
				while(pixie.ib[0] || pixie.ib[2]) GetMouseInstantPosition(&pixie);
			}

			// Insert Point by pressing right mouse button
			if(pixie.ib[2]) {
				if(point.Count() < MAX_APOL) {
					point.AddNext(Point2d(pixie.x,pixie.y));
					i_selected_point = point.Count()-1;
					i_does_redraw = 1;
					BEEP(1500,10);
				}
				else {
					BEEP(750,20);
				}
				while(pixie.ib[2]) GetMouseInstantPosition(&pixie);
			}

			// Move Point by pressing left mouse button
			if(pixie.ib[0]) {
				if(last_press == 0)	i_selected_point = GetNearestPoint(pixie.x, pixie.y, point);

				point[i_selected_point].x = pixie.x;
				point[i_selected_point].y = pixie.y;
				if(last_mouse_x != pixie.x || last_mouse_y != pixie.y) {
					last_mouse_x = pixie.x;
					last_mouse_y = pixie.y;
					i_does_redraw=1;
				}
			}
		}

		else {
			ch=getch();
			#define INCx 1
			i_does_redraw=1;
			switch(ch) {
				case 0x1b: i_does_shut_down=1; break;

                case 'v': bDelaunay = 0; break;
                case 'd': bDelaunay = 1; break;
                case 'f': bDoFill = !bDoFill; break;
                case 'n': bDoVorNeigh = !bDoVorNeigh; break;

				case 'q': point[i_selected_point].y-=INCx; break;
				case 'a': point[i_selected_point].y+=INCx; break;
				case 'o': point[i_selected_point].x-=INCx; break;
				case 'p': point[i_selected_point].x+=INCx; break;
				case 'h': setvisualpage(page); Help(); getch(); i_does_redraw=0; break;

				case '1': setvisualpage(page); voronoi.Render(point, 1); getch(); break;
				case '2': setvisualpage(page); voronoi.Render(point, 2); getch(); break;
				case '3': setvisualpage(page); voronoi.Render(point, 4); getch(); break;
				case '4': setvisualpage(page); voronoi.Render(point, 8); getch(); break;

				case 0x9: i_selected_point++; if(i_selected_point >= point.Count()) i_selected_point=0; break;

				case ' ': cleardevice(); point.Clear(); point.AddNext(Point2d(320,200)); i_selected_point=0; break;
				case 0x08: if(point.Count()>1) { point.DeleteAt(i_selected_point); i_selected_point-=i_selected_point>0; } break;

				case 'x': fScaleDxDy *= fScaleDxDy <8.0? 1.1:1.0; break;
				case 'z': fScaleDxDy *= fScaleDxDy >.1?  0.9:1.0; break;

				case '/':
					point.Clear();
					for(k=0; k<2*3.14159; k+=.3)
						point.AddNext(Point2d(300+250*cos(k),200+250*sin(k)));
					break;

				case '*':
					point.Clear();
					for(k=0; k<2*3.14159; k+=.5)
						point.AddNext(Point2d(300+50*cos(k)+random(20)-10,200+50*sin(k)+random(20)-10));
					break;

				case '-':
					point.Clear();
					for(k=0; k<2*3.14159; k+=.3)
						point.AddNext(Point2d(300+50*cos(k)+random(120)-60,200+50*sin(k)+random(120)-40));
					break;

			}

			assert(point.Count()<MAX_APOL);

		}
	}

	delete apol;

	closegraph();

}

int GetNearestPoint(int x, int y, ArrayP2d& pt) {
	float f_min_dist2=9999999;
	float dist2;
	int i_min_index=-1;

	for(int i=0; i<pt.Count(); i++) {
		dist2 = ((float)pt[i].x-x)*(pt[i].x-x)
			  + ((float)pt[i].y-y)*(pt[i].y-y);
		if( dist2< f_min_dist2) {
			f_min_dist2 = dist2;
			i_min_index = i;
		}
	}
	return i_min_index;

}





void Help(void) {
    #define INC 14
	int ny=-INC;

    outtextxy(0,ny+=INC, "VORONOI DIAGRAM & DELAUNAY TRIANGULATION    by Manuel Guilln Gonzlez");
    outtextxy(0,ny+=INC, "");
    setcolor(YELLOW);
    outtextxy(0,ny+=INC, "Mouse buttons:");
    setcolor(CYAN);
    outtextxy(0,ny+=INC, "  Left     Move point");
    outtextxy(0,ny+=INC, "  Right    Insert point");
    outtextxy(0,ny+=INC, "  Both     Delete point");
    outtextxy(0,ny+=INC, "");
    setcolor(YELLOW);
    outtextxy(0,ny+=INC, "Keyboard:");
    setcolor(CYAN);
    outtextxy(0,ny+=INC, "  q,a,o,p  Move selected point Up, Down, Left, Right");
    outtextxy(0,ny+=INC, "  BKSPACE  Delete selected point");
    outtextxy(0,ny+=INC, "  TAB      Select next point");
    outtextxy(0,ny+=INC, "  Space    Clear all points");
    outtextxy(0,ny+=INC, "  f        Fill polygons in Voronoi diagram");
    outtextxy(0,ny+=INC, "  n        Show neighbours in Voronoi diagram");
    outtextxy(0,ny+=INC, "  z,x      Change initial size of rectangular polygon");
    outtextxy(0,ny+=INC, "");
    outtextxy(0,ny+=INC, "  /,*,-,+  Generate random point configurations");
    outtextxy(0,ny+=INC, "  1,2,3,4  Render Voronoi Diagram at different resolutions");
    outtextxy(0,ny+=INC, "");
    outtextxy(0,ny+=INC, "");
    outtextxy(0,ny+=INC, "  h        Show this help");
    outtextxy(0,ny+=INC, "  ESC      Quit");
    outtextxy(0,ny+=INC, "");

    setcolor(LIGHTRED);
    outtextxy(0,ny+=INC, "Press any key to continue.");


}









void InitGraphics(void) {

   /* request auto detection */
	 int gdriver = VGA, gmode=VGAMED, errorcode;
//   int gdriver = DETECT, gmode, errorcode;

   /* register a driver that was added into graphics.lib */
   /* For information on adding the driver, see the
   /* BGIOBJ section of UTIL.DOC */
   errorcode = registerbgidriver(EGAVGA_driver);

   /* report any registration errors */
   if (errorcode < 0)
   {
      printf("Graphics error: %s\n", grapherrormsg(errorcode));
      printf("Press any key to halt:");
      getch();
      exit(1); /* terminate with an error code */
   }

   /* initialize graphics and local variables */
   initgraph(&gdriver, &gmode, "");

   /* read result of initialization */
   errorcode = graphresult();
   if (errorcode != grOk)  /* an error occurred */
   {
      printf("Graphics error: %s\n", grapherrormsg(errorcode));
      printf("Press any key to halt:");
      getch();
      exit(1); /* terminate with an error code */
   }

}
