#ifndef __VORONOI__
#define __VORONOI__

#include "ArrayP2d.hpp"
#include "Polygon.hpp"
#include <graphics.h>



#define START_VOR_POINT_ARRAY_SIZE      10
//#define INCREMENT_VOR_POINT_ARRAY   3

class Voronoi {
	public:
		int m_ny;  // for debug: printing neighbour params
		int img_dx;  // size of initial rectangular polygon
		int img_dy;

		Voronoi(void);
		~Voronoi();

		int CalcAllPol(ArrayP2d& a_point, Polygon* apol);

		int GetNeighboursList(
		     int nCentralPoint,
		     int nNumberOfPoints,        // = number of polygons
		     Polygon *pPol,              // array of polygons
		     int nMaxNeighbour,          // size of array pnNeighbourList[]
		     int pnNeighbourList[],      // array of neighbours (filled by function)
		     int *pnNeighbourCount);     // number of neighours (filled by function)
		int AreNeighbours(Polygon &pPol1, Polygon &pPol2);
		void Render(ArrayP2d& a_point, int resolution);  // resolution  take values 1,2,3,4...

    private:
		int TryCalcAllPol(ArrayP2d& a_point, Polygon* apol, int* wrong_p, int start_with = 0);
		int CalcPol(ArrayP2d& a_point, Polygon& pol, int i_point);
		Segment Voronoi::GetMidSegment(Point2d& p1, Point2d& p2);

										//    1 = max detail
        // return 0 if found more neighbours than nMaxNeighbours



};

#endif